#include <DFRobot_HX711_I2C.h>
#include <WiFi.h>
#include <PubSubClient.h>
#include <ArduinoJson.h>
#include "DFRobot_Aliyun.h"


#define BEDROOD_LIGHT  D4

/*配置WIFI名和密码*/
const char * WIFI_SSID     = "DFRobot-guest";
const char * WIFI_PASSWORD = "dfrobot@2017";

/*Configure device certificate information*/
String ProductKey = "a11jEzJAeRE";
String ClientId = "12345";/*Custom id*/
String DeviceName = "m6MUlcwgV41dr9rUApym";
String DeviceSecret = "25689626034188ebb001b3148b384963";

/*Configure the domain name and port number*/
String ALIYUN_SERVER = "iot-as-mqtt.cn-shanghai.aliyuncs.com";
uint16_t PORT = 1883;

/*Product identifier that needs to be operated*/
String Identifier = "Alarm_Status";

/*TOPIC that need to be published and subscribed*/
const char * subTopic = "/sys/a11jEzJAeRE/m6MUlcwgV41dr9rUApym/thing/service/property/set";//****set
const char * pubTopic = "/sys/a11jEzJAeRE/m6MUlcwgV41dr9rUApym/thing/event/property/post_reply";//******post

DFRobot_Aliyun myAliyun;
WiFiClient espClient;
PubSubClient client(espClient);
DFRobot_HX711_I2C MyScale;
bool state = 0;

void callback(char * topic, byte * payload, unsigned int len) {
  Serial.print("Recevice [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i = 0; i < len; i++) {
    Serial.print((char)payload[i]);
  }
  Serial.println();
}

void connectWiFi(){
  Serial.print("Connecting to ");
  Serial.println(WIFI_SSID);
  WiFi.begin(WIFI_SSID,WIFI_PASSWORD);
  while(WiFi.status() != WL_CONNECTED){
    delay(500);
    Serial.print(".");
  }
  Serial.println();
  Serial.println("WiFi connected");
  Serial.print("IP Adderss: ");
  Serial.println(WiFi.localIP());
}

void ConnectAliyun(){
  while(!client.connected()){
    Serial.print("Attempting MQTT connection...");
    /*根据自动计算的用户名和密码连接到Alinyun的设备，不需要更改*/
    if(client.connect(myAliyun.client_id,myAliyun.username,myAliyun.password)){
      Serial.println("connected");
      client.subscribe(subTopic);
    }else{
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      delay(5000);
    }
  }
}

void setup() {
  Serial.begin(115200);
  pinMode(BEDROOD_LIGHT, OUTPUT);
  
  while (!MyScale.begin()) {
    Serial.println("The initialization of the chip is failed, please confirm whether the chip connection is correct");
    delay(1000);
  }

  MyScale.setCalWeight(100);

  MyScale.setThreshold(10);

  Serial.println(MyScale.getCalibration());
  MyScale.setCalibration(MyScale.getCalibration());
  
  /*连接WIFI*/
  connectWiFi();

  /*初始化Alinyun的配置，可自动计算用户名和密码*/
  myAliyun.init(ALIYUN_SERVER,ProductKey,ClientId,DeviceName,DeviceSecret);
  
  client.setServer(myAliyun.mqtt_server,PORT);
  
  /*设置回调函数，当收到订阅信息时会执行回调函数*/
  client.setCallback(callback);
  
  /*连接到Aliyun*/
  ConnectAliyun();
  

}

void loop() {
  if(!client.connected()){
    ConnectAliyun();
  }

  if (MyScale.readWeight() > 600 && state == 0 && MyScale.readWeight() < 3000) {
    state = 1;
    digitalWrite(BEDROOD_LIGHT, LOW);
  }
  if (MyScale.readWeight() < 400 && state == 1 && MyScale.readWeight() > 20) {
    state = 0;
    digitalWrite(BEDROOD_LIGHT, HIGH);
    for (int i = 1; i < 6; i++) {
      Serial.print("第几次上传次数：");
      Serial.println(i);
      client.publish(pubTopic, ("{\"id\":" + ClientId + ",\"params\":{\"" + Identifier + "\":"+state+"},\"method\":\"thing.event.property.post\"}").c_str());
      client.loop();
      Serial.println("Data is published to cloud.");
      delay(12000);
    }
  }
    Serial.print(MyScale.readWeight(), 1);
    Serial.println("g");
    delay(500);

}
