#include <DFRobot_HX711_I2C.h>

DFRobot_HX711_I2C MyScale;

float Weight = 0;

bool state = 0;
void setup() {
  Serial.begin(9600);
  while (!MyScale.begin()) {
    Serial.println("The initialization of the chip is failed, please confirm whether the chip connection is correct");
    delay(1000);
  }
  //// Set the calibration weight when the weight sensor module is automatically calibrated (g)
  MyScale.setCalWeight(100);
  // Set the trigger threshold (G) for automatic calibration of the weight sensor module. When only the weight of the object on the scale is greater than this value, the module will start the calibration process
  // This value cannot be greater than the calibration weight of the setCalWeight() setting
  MyScale.setThreshold(10);
  // Obtain the calibration value. The accurate calibration value can be obtained after the calibration operation is completed
  Serial.print("the calibration value of the sensor is: ");
  Serial.println(MyScale.getCalibration());
  MyScale.setCalibration(MyScale.getCalibration());
  delay(1000);
}

void loop() {
  Weight = MyScale.readWeight();
  if(Weight > 700 && state == 0 && Weight < 2000){
    state = 1;
    Serial.println("heavy");
    }
  if(Weight < 400 && state == 1 && Weight > 20){
    state = 0;
    Serial.println("light");
    }
  Serial.print(Weight, 1);
  Serial.println(" g");
  delay(1000);
}
